#include <p30f2012.h>
//
// delay subroutines
//
//===============================================================
// 1us delay

void delay_us(void)
{
    asm("repeat #22");  // for 29.48MHz clock
    asm("nop");
}

//===============================================================
// t*10us delay

void delay_10us(unsigned int t)
{
  unsigned i;

  for (i=0; i<t; i++) {
    asm("repeat #284");  // for 29.48MHz clock
    asm("nop");
  }  
}

//===============================================================
// t*1ms delay

void delay_ms(unsigned int t)
{
	unsigned int	limit;

    PR3 = 0xffff;
    limit = 20000; // 20MHz/1KHz=20000, count of 1 msec 
    T3CON = 0x8000; // T3 ON

    while(t--){
        TMR3 = 0;	// reset timer
        while(TMR3 < limit);	// wait 1msec
    }
    T3CON = 0;
}


#if 0
void delay_ms(unsigned int t)
{
  unsigned int i, j;

  for (i=0; i<t; i++) {
    for (j=0; j<100; j++) {
      asm("repeat #286");  // for 29.48MHz clock
      asm("nop");
    }
  }  
}
#endif

// end of delay.c
